commit 5a27a6cd75d31502f7a36568c0055d191b285518
Author: jklowden <jklowden>
Date:   Mon Jan 11 18:04:04 2010 +0000

    more care with strcasecmp macro

diff --git a/ChangeLog b/ChangeLog
index d2361b8..05573f6 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Jan 11 13:03:29 EST 2010	JK Lowden <jklowden@freetds.org>
+	* include/replacements.h more care with strcasecmp macro
+
 Mon Jan 11 19:00:10 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/log.c: removed wrongly committed patch
 
@@ -2110,4 +2113,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2936 2010/01/11 18:00:16 freddy77 Exp $
+$Id: ChangeLog,v 1.2937 2010/01/11 18:04:04 jklowden Exp $
diff --git a/include/replacements.h b/include/replacements.h
index a24bb0b..bde9cff 100644
--- a/include/replacements.h
+++ b/include/replacements.h
@@ -20,7 +20,7 @@
 #ifndef _replacements_h_
 #define _replacements_h_
 
-/* $Id: replacements.h,v 1.24 2010/01/11 14:03:17 jklowden Exp $ */
+/* $Id: replacements.h,v 1.25 2010/01/11 18:04:04 jklowden Exp $ */
 
 #include <stdarg.h>
 #include "tds_sysdep_public.h"
@@ -96,11 +96,24 @@ size_t tds_strlcat(char *dest, const char *src, size_t len);
 char *tds_basename(char *path);
 #endif
 
+/* 
+ * Microsoft's C Runtime library is missing strcasecmp and strncasecmp. 
+ * Other Win32 C runtime libraries, notably minwg, may define it. 
+ * There is no symbol uniquely defined in Microsoft's header files that 
+ * can be used by the preprocessor to know whether we're compiling for
+ * Microsoft's library or not (or which version).  Thus there's no
+ * way to automatically decide whether or not to define strcasecmp
+ * in terms of stricmp.  
+ * 
+ * The Microsoft *compiler* defines _MSC_VER.  On the assumption that
+ * anyone using their compiler is also using their library, the below 
+ * tests check _MSC_VER as a proxy. 
+ */
 #if defined(_WIN32)
-# if !defined(strcasecmp) 
+# if !defined(strcasecmp) && defined(_MSC_VER) 
 #     define  strcasecmp(A, B) stricmp((A), (B))
 # endif
-# if !defined(strncasecmp) 
+# if !defined(strncasecmp) && defined(_MSC_VER)
 #     define  strncasecmp(x,y,z) strnicmp((x),(y),(z))
 # endif
 int gettimeofday (struct timeval *tv, void *tz);

